# Copyright(c) 2000-2004 Association of Universities for Research in Astronomy, Inc.
#
# Package script for the gemtools package
#
# Version: Sept 14, 2002 BR,IJ  Release v1.4
#          Jan   9, 2004 KL     Release v1.5
#          Apr  19, 2004 KL     Release v1.6
#          Oct  25, 2004 KL     Release v1.7
#
# load necessary packages - if anything else than loaded
# by gemini should be necessary
specred
# Load the NMISC package.
if (deftask("nmisc")==no) {
   print("ERROR: The NMISC package is required but not defined.")
   bye()
}
;
nmisc

package gemtools

# Co-addition of direct images, same task in all packages
task      imcoadd=gemtools$imcoadd.cl


# MONGO like graphs
task      mgograph=gemtools$mgograph.cl

# Seeing determination
task      gemseeing=gemtools$gemseeing.cl

# Generic arithmetic for MEF images/spectra
# DQ handling
# MEF combine
task      gemcombine=gemtools$gemcombine.cl



# Headers
task      gemhead=gemtools$gemhead.cl

# hidden
task      printlog=gemtools$printlog.cl
hidetask printlog
task gsetsec=gemtools$gsetsec.cl
hidetask gsetsec

task      gextverify=gemtools$gextverify.cl
task      gimverify=gemtools$gimverify.cl
task      gemvsample=gemtools$gemvsample.cl
task      gemhedit=gemtools$gemhedit.cl
task      gemqa=gemtools$gemqa.cl
task      gemlogname=gemtools$gemlogname.cl
task      gemoffsetlist=gemtools$gemoffsetlist.cl
task	gemlist = gemtools$gemlist.cl

hidetask("gimverify","gextverify")

# MEF handling 
task      wmef=gemtools$wmef.cl
task	gemwcscopy=gemtools$gemwcscopy.cl
hidetask gemwcscopy

# Compiled tasks 
task	gemextn		= "gemtools$x_gemtools.e"
task	gloginit	= "gemtools$x_gemtools.e"
task	glogprint	= "gemtools$x_gemtools.e"
task	glogclose	= "gemtools$x_gemtools.e"
task	glogextract	= "gemtools$x_gemtools.e"
task	glogfix		= "gemtools$x_gemtools.e"
task	glogpars	= "gemtools$glogpars.par"

hidetask("gloginit","glogprint","glogclose")

# GEMEXPR compiled into gemexpr
task	gemarith	= "gemtools$x_gemexpr.e"
task 	gemexpr	= "gemtools$x_gemexpr.e"
task    gemexprpars = "gemtools$gemexprpars.par"; hidetask gemexprpars
task	mimexprpars = "gemtools$mimexprpars.par"; hidetask mimexprpars
clbye()
