# Copyright(c) 2001-2004 Association of Universities for Research in Astronomy, Inc.

procedure nscalibrate (object, standard)

# Written Jul 2000 - Marianne Takamiya
# Minor changes: 1 Aug 2000 - MT
#
# Version  Aug 29, 2003  KL, IRAF2.12 - new parameter, addonly, in hedit
#                              The hedit calls are currently commented out but
#                              might as well fix them in cas this changes in 
#                              the future.
#	   Oct 29, 2003  KL  moved from niri to gnirs

string	object		{prompt = "Object spectra to calibrate"}
string	standard	{prompt = "Standard star spectrum"}
string	starnames	{"",prompt = "Star names in calibration list (used to find cal tables)"}
string	output		{"", prompt = "Output flux calibrated object spectra"}
string	outprefix	{"c", prompt = "Output prefix"}

string	obj_airmass	{"", prompt = "Object airmass value(s) or list of values"}
string	std_airmass	{"", prompt = "Standard star airmass value(s) or list of values"}

string	obj_exptime	{"", prompt = "Object exptime value(s) or list of values"}
string	std_exptime	{"", prompt = "Standard star exptime value(s) or list of values"}

string	mag		{"", prompt = "Standard star magnitude value(s)"}
string	magband		{"", prompt = "Band of standard star magnitude value(s)"}
string	teff		{"", prompt = "Effective temperature of spectral type of standard star"}

real	bandwidth	{INDEF, prompt = "Bandpass width"}
real	bandsep		{INDEF, prompt = "Bandpass separation"}
real	fnuzero		{3.68E-20, prompt = "Absolute flux zero point"}
string	caldir		{"onedstds$blackbody/", prompt = "Directory containing calibration data"}
string	observatory	{"gemini-south", prompt = "Observatory"}

string	in_extinction	{"", prompt = "Input extinction file"}
string	out_extinction	{"extinct.dat", prompt = "Output extinction file"}
string	function	{"spline3", prompt = "Fitting function"}
int	order		{6, min=1, prompt="Order of fit"}
string	graphs		{"sr", prompt = "Graphs per frame"}
struct	marks		{"plus cross box", prompt = "Data mark types (marks deleted added)"}
struct	colors		{"2 1 3 4", prompt = "Colors (lines marks deleted added)"}

bool	fl_extinct	{yes, prompt = "Apply extinction correction to object?"}
bool	fl_flux		{yes, prompt = "Apply flux calibration to object?"}

bool	fl_fnu		{no, prompt = "Create spectra having units of FNU?"}

int	dispaxis	{1, min = 1, max = 2, prompt = "Dispersion axis"}
int	line		{500, prompt = "Disperson line"}
int	nsum		{10, prompt = "Number of dispersion lines to sum or median"}
string	background	{"none", prompt = "Background to subtract (none|average|fit)"}
bool	fl_findneg	{no, prompt = "Find and extract a negative spectrum?"}
real	upper		{40, prompt = "Upper aperture limit relative to center"}
real	lower		{-40, prompt = "Lower aperture limit relative to center"}
bool	fl_answer	{yes, prompt = "Answer to task standard (no|yes|NO|YES|NO!|YES!)"}
bool	fl_inter	{no, prompt = "Run task interactive?"}
bool	verbose		{yes, prompt = "Run task verbosely"}

string	sfile		{"std", prompt = "Output flux file (used by SENSFUNC)"}
string	sfunction	{"sens", prompt = "Output root sensitivity function imagename"}

string	logfile		{"", prompt = "Logfile"}
int	status		{0, prompt="Output status of the task"}

struct	*scanfile1	{prompt = "Internal use only"}
struct	*scanfile2	{prompt = "Internal use only"}
struct	*scanfile3	{prompt = "Internal use only"}



begin

	string	l_object = ""
	string	l_standard = ""
	string	l_starnames = ""
	string	l_output = ""
	string	l_outprefix = ""
	string	l_obj_airmass = ""
	string	l_std_airmass = ""
	string	l_obj_exptime = ""
	string	l_std_exptime = ""
	string	l_mag = ""
	string	l_magband = ""
	string	l_teff = ""
	real	l_bandwidth
	real	l_bandsep
	real	l_fnuzero
	string	l_caldir = ""
	string	l_observatory = ""
	string	l_in_extinction = ""
	string	l_out_extinction = ""
	string	l_function = ""
	int	l_order
	string	l_graphs = ""
	string	l_marks = ""
	string	l_colors = ""
	bool	l_fl_extinct
	bool	l_fl_flux
	bool	l_fl_fnu
	int	l_dispaxis
	int	l_line
	int	l_nsum
	string	l_background = ""
	bool	l_fl_findneg
	real	l_upper
	real	l_lower
	bool	l_fl_answer
	bool	l_fl_inter
	bool	l_verbose
	string	l_sfile = ""
	string	l_sfunction = ""
	string	l_logfile = ""

	char	tmpin, tmpst, tmpnm, tmpmg, tmpmb, tmpte, tmpout, tmpex, tmpio
	char	tmpams, tmpets, tmptaskout, tmpamo, tmpeto
	char	tmpnoise, tmpsci, tmpvar, tmpobj, tmpdq
	char	insci, invar, indq, imgex, imgin, imgout
	char	outsci, outvar, outdq, phu
	int	nin, nst, nver, ver, daxis, nbad
	char	stnd, band, name, expr
	real	temp, stdairm, objairm, objexpt, stdexpt, magn, objres
	struct	sline
	bool	debug, dostandard, dosensfunc, first, newstd
	char	imagesdel, filesdel, keyfound

	char	l_sci_ext = ""
	char	l_var_ext = ""
	char	l_dq_ext = ""
	char	l_key_airmass = ""
	char	l_key_exptime = ""
	char	l_key_dispaxis = ""
	int	junk
	char	badhdr


	junk = fscan (	object, l_object)
	junk = fscan (	standard, l_standard)
	junk = fscan (	starnames, l_starnames)
	junk = fscan (	output, l_output)
	junk = fscan (	outprefix, l_outprefix)
	junk = fscan (	obj_airmass, l_obj_airmass)
	junk = fscan (	std_airmass, l_std_airmass)
	junk = fscan (	obj_exptime, l_obj_exptime)
	junk = fscan (	std_exptime, l_std_exptime)
	junk = fscan (	mag, l_mag)
	junk = fscan (	magband, l_magband)
	junk = fscan (	teff, l_teff)
	l_bandwidth =	bandwidth
	l_bandsep =	bandsep
	l_fnuzero =	fnuzero
	junk = fscan (	caldir, l_caldir)
	junk = fscan (	observatory, l_observatory)
	junk = fscan (	in_extinction, l_in_extinction)
	junk = fscan (	out_extinction, l_out_extinction)
	junk = fscan (	function, l_function)
	l_order =		order
	junk = fscan (	graphs, l_graphs)
	junk = fscan (	marks, l_marks)
	junk = fscan (	colors, l_colors)
	l_fl_extinct =	fl_extinct
	l_fl_flux =	fl_flux
	l_fl_fnu =	fl_fnu
	l_dispaxis =	dispaxis
	l_line =	line
	l_nsum =		nsum
	junk = fscan (	background, l_background)
	l_fl_findneg =	fl_findneg
	l_upper =	upper
	l_lower =	lower
	l_fl_answer =	fl_answer
	l_fl_inter =	fl_inter
	l_verbose =	verbose
	junk = fscan (	sfile, l_sfile)
	junk = fscan (	sfunction, l_sfunction)
	junk = fscan (	logfile, l_logfile)


	status = 1
	debug = no

	badhdr = ""
	junk = fscan (	nsheaders.sci_ext, l_sci_ext)
	if ("" == l_sci_ext) badhdr = badhdr + " sci_ext"
	junk = fscan (	nsheaders.var_ext, l_var_ext)
	if ("" == l_var_ext) badhdr = badhdr + " var_ext"
	junk = fscan (	nsheaders.dq_ext, l_dq_ext)
	if ("" == l_dq_ext) badhdr = badhdr + " dq_ext"
	junk = fscan (	nsheaders.key_airmass, l_key_airmass)
	if ("" == l_key_airmass) badhdr = badhdr + " key_airmass"
	junk = fscan (	nsheaders.key_exptime, l_key_exptime)
	if ("" == l_key_exptime) badhdr = badhdr + " key_exptime"
	junk = fscan (	nsheaders.key_dispaxis, l_key_dispaxis)
	if ("" == l_key_dispaxis) badhdr = badhdr + " key_dispaxis"


	# Make temp files
	tmpin = mktemp ("tmpin")
	tmpst = mktemp ("tmpst")
	tmpnm = mktemp ("tmpnm")
	tmpmg = mktemp ("tmpmg")
	tmpmb = mktemp ("tmpmb")
	tmpte = mktemp ("tmpte")
	tmpout = mktemp ("tmpout")
	tmpio = mktemp ("tmpio")
	tmpams = mktemp ("tmpams")
	tmpets = mktemp ("tmpets")
	tmpamo = mktemp ("tmpamo")
	tmpeto = mktemp ("tmpeto")
	tmptaskout = mktemp ("tmptaskout")
	tmpex = mktemp ("tmpex")

	filesdel = tmpamo // "," // tmpams // "," \
	    // tmpeto // "," // tmpets // "," //  tmpex // "," \
	    // tmpin // "," // tmpio // "," // tmpmb // "," // tmpmg // "," \
	    // tmpnm // "," // tmpout // "," // tmpst // "," // tmpte
	imagesdel = ""

	# Cache some important tasks
	cache ("gemextn", "keypar", "nsextract")


	# Broadcast what will be done:
	date | scan (sline)
	printlog ("-----------------------------------------------------\
	    ---------------------------", l_logfile, l_verbose)
	printlog ("NSCALIBRATE -- " // sline, l_logfile, l_verbose)
	printlog ("", l_logfile, l_verbose)
	printlog ("     object = " // l_object, l_logfile, l_verbose)
	printlog ("   standard = " // l_standard, l_logfile, l_verbose)
	printlog ("  starnames = " // l_starnames, l_logfile, l_verbose)
	printlog ("    sci_ext = " // l_sci_ext, l_logfile, l_verbose)
	printlog ("    var_ext = " // l_var_ext, l_logfile, l_verbose)
	printlog ("     dq_ext = " // l_dq_ext, l_logfile, l_verbose)
	printlog ("obj_airmass = " // l_obj_airmass, l_logfile, l_verbose)
	printlog ("std_airmass = " // l_std_airmass, l_logfile, l_verbose)
	printlog ("key_airmass = " // l_key_airmass, l_logfile, l_verbose)
	printlog ("obj_exptime = " // l_obj_exptime, l_logfile, l_verbose)
	printlog ("std_exptime = " // l_std_exptime, l_logfile, l_verbose)
	printlog ("key_exptime = " // l_key_exptime, l_logfile, l_verbose)
	printlog ("        mag = " // l_mag, l_logfile, l_verbose)
	printlog ("    magband = " // l_magband, l_logfile, l_verbose)
	printlog ("       teff = " // l_teff, l_logfile, l_verbose)
	printlog ("", l_logfile, l_verbose)


	# Deal with the logfile first
	# Check that logfile is not an empty string, otherwise, 
	# use default: gnirs.log

	if ((l_logfile == "")) {
	    l_logfile = gnirs.logfile
	    if ((l_logfile == "")) {
		l_logfile = "gnirs.log"
		printlog ("WARNING - NSCALIBRATE: Both nscalibrate.logfile \
		    and gnirs.logfile are", l_logfile, verbose+)
		printlog ("                      empty.  Using gnirs.log.",
		    l_logfile, verbose+)
	    }
	}

	if ("" != badhdr) {
            printlog ("ERROR - NSCALIBRATE: Parameter(s) missing from \
		nsheaders: " // badhdr, l_logfile, verbose+) 
            goto clean
	}
 

	# Determine if the sensitivity file and functions already exist. 
	# If so, do not run standard nor sensfunc.

	dostandard = yes; dosensfunc = yes


	# Check that sfile is not empty

	if (access (l_sfile)) {
	    printlog ("WARNING - NSCALIBRATE: using existing sensitivity \
		file (" // l_sfile // ")", l_logfile, verbose+)
	    printlog ("                       Task STANDARD will not be \
		executed.", l_logfile, verbose+)
	    dostandard = no
	} else if (l_sfile == "") {
	    l_sfile = mktemp ("tmpsf")
	    filesdel = filesdel // "," // l_sfile
	}


	# Check that sfunction is not empty

	if (imaccess (l_sfunction)) {
	    printlog ("WARNING - NSCALIBRATE: using existing sensitivity \
		function (" // l_sfunction // ")", l_logfile, verbose+)
	    printlog ("                       Task SENSFUNC will not be \
		executed.", l_logfile, verbose+)
	    dosensfunc = no
	} else if (l_sfunction == "") {
	    l_sfunction = mktemp ("tempsi")
	    imagesdel = imagesdel // "," // l_sfunction
	}


	# Process input

	gemextn (l_object, check="mef,exists", process="none", index="", \
	    extname="", extversion="", ikparams="", omit="extension, kernel", \
	    replace="", outfile=tmpin, logfile="", glogpars="",
	    verbose=l_verbose)
	if (0 == gemextn.count || 0 != gemextn.fail_count) {
	    printlog ("ERROR - NSCALIBRATE: problem with input data.",
		l_logfile, yes)
	    goto clean
	}
	nin = gemextn.count


	# Check for preparedness too

	nbad = 0
	scanfile1 = tmpin
	while (fscan (scanfile1, imgin) != EOF) {
	    phu = imgin // "[0]"
	    keyfound=""
	    hselect(phu, "*PREPAR*", yes) | scan(keyfound)
	    if (keyfound == "") {
		printlog ("ERROR - NSCALIBRATE: Image " // imgin \
		    // " not PREPAREd.", l_logfile, l_verbose) 
		nbad += 1
	    }
	}

        if (nbad > 0) {
            printlog ("ERROR - NSCALIBRATE: " // nbad // " image(s) \
		have not been run through *PREPARE", l_logfile, verbose+) 
            goto clean
        }


	# Check/read object airmass

	if ("" != l_obj_airmass) {
	    files (l_obj_airmass, > tmpamo)
	    count (tmpamo) | scan (junk)
	    if (junk != nin) {
		printlog ("ERROR - NSCALIBRATE: provide an airmass for each \
		    object", l_logfile, verbose+)
		printlog ("                     (" // nin // " objects \
		    and " // junk // " airmasses)", l_logfile, verbose+)
		goto clean
	    }
	} else {
	    scanfile1 = tmpin
	    while (fscan (scanfile1, imgin) != EOF) {

		phu = imgin // "[0]"
		keypar (phu, l_key_airmass)
		if (keypar.found) {
		    print (keypar.value, >> tmpamo)
		} else {

		    # I don't understand this...

		    printlog ("WARNING - NSCALIBRATE: airmass of object " //
			imgin // " is unknown.", l_logfile, verbose+)
		    printlog ("                       Observatory latitude \
			will be used instead.", l_logfile, verbose+)

		    if ("" == l_observatory) {
			printlog("ERROR - NSCALIBRATE: parameter observatory \
			    is empty string.", l_logfile, verbose+)
			   goto clean
		    } else {
			print ("INDEF", >> tmpamo)
		    }
		}
	    }
	}


	# Check/read object exposure time

	if ("" != l_obj_exptime) {
	    files (l_obj_exptime, > tmpeto)
	    count (tmpeto) | scan (junk)
	    if (junk != nin) {
		printlog ("ERROR - NSCALIBRATE: provide an exptime for each \
		    object", l_logfile, verbose+)
		printlog ("                     (" // nin // " objects \
		    and " // junk // " exptimes)", l_logfile, verbose+)
		goto clean
	    }
	} else {
	    scanfile1 = tmpin
	    while (fscan (scanfile1, imgin) != EOF) {

		phu = imgin // "[0]"
		keypar (phu, l_key_exptime)
		if (keypar.found) {
		    print (keypar.value, >> tmpeto)
		} else {
		    printlog ("ERROR - NSCALIBRATE: exptime (" \
			// l_key_exptime // ") missing from " // phu, \
			l_logfile, verbose+)
		    goto clean
		}
	    }
	}


	# Check the input standard star images

	gemextn (l_standard, check="mef,exists", process="none", index="", \
	    extname="", extversion="", ikparams="", omit="extension, kernel", \
	    replace="", outfile=tmpst, logfile="", glogpars="",
	    verbose=l_verbose)
	if (0 == gemextn.count || 0 != gemextn.fail_count) {
	    printlog ("ERROR - NSCALIBRATE: problem with standard star data.",
		l_logfile, yes)
	    goto clean
	}
	nst = gemextn.count
	if (1 != nst && nin != nst) {
	    printlog ("ERROR - NSCALIBRATE: provide a single standard star, \
		or one for each obs", l_logfile, verbose+)
	    printlog ("                     (" // nin // " observations \
		and " // nst // " standards)", l_logfile, verbose+)
	    goto clean
	}


	# Check/read standard airmass

	if ("" != l_std_airmass) {
	    files (l_std_airmass, > tmpams)
	    count (tmpams) | scan (junk)
	    if (junk != nst) {
		printlog ("ERROR - NSCALIBRATE: provide an airmass for each \
		    standard", l_logfile, verbose+)
		printlog ("                     (" // nst // " standards \
		    and " // junk // " airmasses)", l_logfile, verbose+)
		goto clean
	    }
	} else {
	    scanfile1 = tmpin
	    while (fscan (scanfile1, stnd) != EOF) {

		phu = stnd // "[0]"
		keypar (phu, l_key_airmass)
		if (keypar.found) {
		    print (keypar.value, >> tmpams)
		} else {

		    # I don't udnerstand this...

		    printlog ("WARNING - NSCALIBRATE: airmass of standard " //
			stnd // " is unknown.", l_logfile, verbose+)
		    printlog ("                       Observatory latitude \
			will be used instead.", l_logfile, verbose+)

		    if ("" == l_observatory) {
			printlog("ERROR - NSCALIBRATE: parameter observatory \
			    is empty string.", l_logfile, verbose+)
			   goto clean
		    } else {
			print ("INDEF", >> tmpams)
		    }
		}
	    }
	}


	# Check/read standard exposure time

	if ("" != l_std_exptime) {
	    files (l_std_exptime, > tmpets)
	    count (tmpets) | scan (junk)
	    if (junk != nst) {
		printlog ("ERROR - NSCALIBRATE: provide an exptime for each \
		    standard", l_logfile, verbose+)
		printlog ("                     (" // nst // " standards \
		    and " // junk // " exptimes)", l_logfile, verbose+)
		goto clean
	    }
	} else {
	    scanfile1 = tmpst
	    while (fscan (scanfile1, stnd) != EOF) {

		phu = stnd // "[0]"
		keypar (phu, l_key_exptime)
		if (keypar.found) {
		    print (keypar.value, >> tmpets)
		} else {
		    printlog ("ERROR - NSCALIBRATE: exptime (" \
			// l_key_exptime // ") missing from " // phu, \
			l_logfile, verbose+)
		    goto clean
		}
	    }
	}


	# Now check the starnames parameter

	if ("" == l_starnames) {
	    printlog ("ERROR - NSCALIBRATE: no standard star names",
		l_logfile, verbose+)
	    goto clean
	}
	files (l_starnames, > tmpnm)
	count (tmpnm) | scan (junk)
	if (junk != nst) {
	    printlog ("ERROR - NSCALIBRATE: provide a name for each \
		standard", l_logfile, verbose+)
	    printlog ("                     (" // nst // " standards \
		and " // junk // " names)", l_logfile, verbose+)
	    goto clean
	}


	# Now check the MAG parameter

	files (l_mag, > tmpmg)
	count (tmpmg) | scan (junk)
	if (junk != nst) {
	    printlog ("ERROR - NSCALIBRATE: provide a magnitude for each \
		standard", l_logfile, verbose+)
	    printlog ("                     (" // nst // " standards \
		and " // junk // " magnitudes)", l_logfile, verbose+)
	    goto clean
	}


	# Now check the MAGBAND parameter

	files (l_magband, > tmpmb)
	count (tmpmb) | scan (junk)
	if (junk != nst) {
	    printlog ("ERROR - NSCALIBRATE: provide a magnitude band for each \
		standard", l_logfile, verbose+)
	    printlog ("                     (" // nst // " standards \
		and " // junk // " bands)", l_logfile, verbose+)
	    goto clean
	}


	# Now check the TEFF parameter

	files (l_teff, > tmpte)
	count (tmpte) | scan (junk)
	if (junk != nst) {
	    printlog ("ERROR - NSCALIBRATE: provide a temperature for each \
		standard", l_logfile, verbose+)
	    printlog ("                     (" // nst // " standards \
		and " // junk // " temperatures)", l_logfile, verbose+)
	    goto clean
	}


	# Now check the CALDIR parameter

	if (l_caldir == "") {
	    printlog ("ERROR - NSCALIBRATE: parameter caldir is empty string.",
		l_logfile, yes)
	    goto clean
	}


	# And the output files...

	gemextn (l_output, check="absent", process="none", index="", \
	    extname="", extversion="", ikparams="", omit="extension,kernel", \
	    replace="", outfile=tmpout, logfile="", glogpars="",
	    verbose=l_verbose)
	if (0 != gemextn.fail_count) {
	    printlog ("ERROR - NSCALIBRATE: problems with output files.", \
		l_logfile, verbose+)
	    goto clean
	}
	if (0 == gemextn.count) {
	    gemextn ("%^%" // l_outprefix // "%" // "@" // tmpin, \
		check="absent", process="none", index="", \
		extname="", extversion="", ikparams="", omit="kernel,exten", \
		replace="", outfile=tmpout, logfile="", glogpars="",
		verbose=l_verbose)
	    if (gemextn.fail_count != 0 || gemextn.count == 0) {
		printlog ("ERROR - NSCALIBRATE: no or incorrectly formatted \
		    output files.", l_logfile, verbose+) 
		goto clean
	    }
	} else if (nin != gemextn.count) {
	    printlog ("ERROR - NSCALIBRATE: provide an output for each \
		input (or use outprefix)", l_logfile, verbose+)
	    printlog ("                     (" // nin // " inputs \
		and " // gemextn.count // " outputs)", l_logfile, verbose+)
	    goto clean
	}


	# Before determining the sensitivity function, extract the 1D
	# spectrum

	scanfile1 = tmpst
	while (fscan (scanfile1, stnd) != EOF) {

	    gemextn (stnd, check="mef,exists", process="expand", index="", \
		extname=l_sci_ext, extversion="1-", ikparams="", omit="", \
		replace="", outfile="STDOUT", logfile="", glogpars="",
		verbose-) | scan (insci)
	    if (gemextn.count == 0) {
		printlog ("ERROR - NSCALIBRATE: no science data for " \
		    // stnd, l_logfile, verbose+)
		goto clean
	    }

	    keypar (insci, "i_naxis")
	    if (keypar.found && int (keypar.value) > 1) {

		imgex = mktemp ("imgex")
		imagesdel = imagesdel // "," // imgex

		nsextract (stnd, imgex, logfile=l_logfile, sn_stats="midpt", \
		    line=l_line, nsum=l_nsum, upper=l_upper, lower=l_lower, \
		    background=l_background, fl_addvar+, fl_skylines+, \
		    fl_inter=l_fl_inter, fl_apall+, fl_trace-, \
		    aptable="gnirs$data/apertures.fits", fl_project-, \
		    fl_findneg=l_fl_findneg, bgsample="*", \
		    trace="", tr_nsum=10, tr_step=10, tr_nlost=3, \
		    tr_function="legendre", tr_order=20, tr_sample="*", \
		    tr_naver=1, tr_niter=0, tr_lowrej=3, tr_highrej=3, \
		    tr_grow=0, verbose=l_verbose)

		if (0 != nsextract.status) {
		    printlog ("ERROR - NSCALIBRATE: extraction failed for " \
			// stnd, l_logfile, verbose+)
		    goto clean
		}

	    } else {
		imgex = stnd
	    }

	    print (imgex, >> tmpex)
	}


	# Join files into combined lists to reduce the number of
	# files to scan

	delete (tmpst, verify-, >& "dev$null")
	join (tmpex // "," // tmpte // "," // tmpmb // "," // tmpmg \
	    // "," // tmpams // "," // tmpets // "," // tmpnm, output=tmpst, \
	    delim=" ", verbose-)
	join (tmpin // "," // tmpout // "," // tmpamo // "," // tmpeto, \
	    output=tmpio, delim=" ", verbose-)

	scanfile1 = tmpio
	scanfile2 = tmpst
	first = yes

	while (fscan (scanfile1, imgin, imgout, objairm, objexpt) != EOF) {
	
	    newstd = no

	    if (first || nst > 1) {
		junk = fscan (scanfile2, stnd, temp, band, magn, \
		    stdairm, stdexpt, sline)
		name = sline
		newstd = yes

		if (debug) {
		    print ("in: " // imgin)
		    print ("out: " // imgout)
		    print ("stnd: " // stnd)
		    print ("temp: " // temp)
		    print ("band: " // band)
		    print ("magn: " // magn)
		    print ("name: " // name)
		    print ("airm: " // stdairm)
		    print ("expt: " // stdexpt)
		}

		gemextn (stnd, check="mef,exists", process="expand", \
		    index="", extname=l_sci_ext, extversion="1-", \
		    ikparams="", omit="", replace="", outfile="dev$null", \
		    logfile="", glogpars="", verbose-)
		nver = gemextn.count

		gemextn (stnd, check="mef,exists", process="expand", \
		    index="", extname=l_sci_ext, extversion="1-" // nver, \
		    ikparams="", omit="", replace="", outfile="dev$null", \
		    logfile="", glogpars="", verbose-)
		if (0 == gemextn.count || 0 != gemextn.fail_count || \
		    nver != gemextn.count) {
		    printlog ("ERROR - NSCALIBRATE: problem accessing \
			standard star science data.", l_logfile, verbose+)
		    goto clean
		}
		if (debug) print (stnd // " has " // nver // " sci extns")

	    }


	    for (ver = 1; ver <= nver; ver = ver+1) {


		if (dostandard && newstd) {

		    if (ver > 1) {
			insci = stnd // "[" // l_sci_ext // "," // ver // "]"
		    } else {
			insci = stnd // "[" // l_sci_ext // "]"
		    }

		    date | scan (sline)
		    delete (tmptaskout, ver-, >& "dev$null")

		    # Now we are ready to get the add the standard
		    # star to the sensitivity file using the task
		    # standard in the specred package. The standard
		    # task in the longslit package has not been
		    # updated yet.

		    if (debug) {
			print ("calling specred.standard")
			specred.standard (insci, l_sfile, name, stdairm, \
			    exptime=stdexpt, mag=magn, magband=band, \
			    teff=temp, interact=l_fl_inter, samestar=yes, \
			    beam_switch=no, apertures="", \
			    bandwidth=l_bandwidth, bandsep=l_bandsep, \
			    fnuzero=l_fnuzero, extinction="", \
			    caldir=l_caldir, graphics="stdgraph", \
			    cursor="", observatory=l_observatory, \
			    answer=l_fl_answer)
			print ("")
		    } else {
			specred.standard (insci, l_sfile, name, stdairm, \
			    exptime=stdexpt, mag=magn, magband=band, \
			    teff=temp, interact=l_fl_inter, samestar=yes, \
			    beam_switch=no, apertures="", \
			    bandwidth=l_bandwidth, bandsep=l_bandsep, \
			    fnuzero=l_fnuzero, extinction="", \
			    caldir=l_caldir, graphics="stdgraph", \
			    cursor="", observatory=l_observatory, \
			    answer=l_fl_answer, >& tmptaskout)

			printlog ("", l_logfile, l_verbose)
			printlog ("STANDARD -- " // sline, \
			    l_logfile, l_verbose)
			scanfile3 = tmptaskout
			while (fscan (scanfile3, sline) != EOF) {
			    printlog (sline, l_logfile, l_verbose)
			}
			delete (tmptaskout, ver-, >& "dev$null")
		    }

		}


		if (dosensfunc && newstd) {

		    date | scan (sline)
		    delete (tmptaskout, ver-, >& "dev$null")

		    # Determine the sensitivity and extinction
		    # functions with the task sensfunc. The sensfunc
		    # appears to be the same in the longslit and
		    # onedspec packages. Note all the objects are run
		    # with the same standard star calibrations.

		    if (debug) {
			print "calling specred.sensfunc"
			specred.sensfunc (l_sfile, l_sfunction, \
			    answer=l_fl_answer, apertures="", \
			    ignoreaps=yes, logfile=l_logfile, extinction="", \
			    newextinction=l_out_extinction, \
			    observatory=l_observatory, function=l_function, \
			    order=l_order, interactive=l_fl_inter, \
			    graphs=l_graphs, marks=l_marks, colors=l_colors, \
			    cursor="", device="stdgraph")
			print ("")
		    } else {
			specred.sensfunc (l_sfile, l_sfunction, \
			    answer=l_fl_answer, apertures="", \
			    ignoreaps=yes, logfile=l_logfile, extinction="", \
			    newextinction=l_out_extinction, \
			    observatory=l_observatory, function=l_function, \
			    order=l_order, interactive=l_fl_inter, \
			    graphs=l_graphs, marks=l_marks, colors=l_colors, \
			    cursor="", device="stdgraph", >& tmptaskout)

			printlog ("", l_logfile, l_verbose)
			printlog ("SENSFUNC -- " // sline, \
			    l_logfile, l_verbose)
			scanfile3 = tmptaskout
			while (fscan (scanfile3, sline) != EOF) {
			    printlog (sline, l_logfile, l_verbose)
			}
			delete (tmptaskout, ver-, >& "dev$null")
		    }
		}


		# Finally, run calibrate on the objects, again from
		# the onedspec package


		date | scan (sline)
		tmpsci = mktemp ("tmpsci")
		imagesdel = imagesdel // "," // tmpsci

		insci = imgin //  "[" // l_sci_ext // "," // ver // "]"
		outsci = l_sfunction

		keypar (insci, l_key_dispaxis)
		if (keypar.found) daxis = int (keypar.value)
		else daxis = l_dispaxis

		if (debug) {
		    print ("calling specred.calibrate")
		    specred.calibrate (insci, tmpsci, airmass=objairm, \
			exptime=objexpt, extinct=l_fl_extinct, \
			flux=l_fl_flux, extinction=l_in_extinction, \
			observatory=l_observatory, ignoreaps=yes, \
			sensitivity=outsci, fnu=l_fl_fnu)
		    print ("done")
		} else {
		    specred.calibrate (insci, tmpsci, airmass=objairm, \
			exptime=objexpt, extinct=l_fl_extinct, \
			flux=l_fl_flux, extinction=l_in_extinction, \
			observatory=l_observatory, ignoreaps=yes, \
			sensitivity=outsci, fnu=l_fl_fnu, \
			>& tmptaskout)

		    printlog ("", l_logfile, l_verbose)
		    printlog ("CALIBRATE -- " // sline, l_logfile, l_verbose)
		    scanfile3 = tmptaskout
		    while (fscan (scanfile3, sline) != EOF) {
			printlog (sline, l_logfile, l_verbose)
		    }
		    delete (tmptaskout, ver-, >& "dev$null")
		}


		# Make var plane of object
		# Construct "noiseless" sensfunction in units of
		# count/s/A/ergs/cm^2/s/A stored in tmpnoise

		tmpnoise = mktemp ("tmpnoise")
		tmpvar = mktemp ("tmpvar")
		tmpobj = mktemp ("tmpobj")

		imagesdel = imagesdel // "," // tmpnoise // "," // tmpobj \
		    // "," // tmpvar

		keypar (insci, "CD" // daxis // "_" // daxis)
		if (keypar.found) {
		    if (debug) print ("CD1_1: " // keypar.value)
		    objres = real (keypar.value)
		} else {
		    printlog ("ERROR - NSCALIBRATE: No resolution info in " \
			// insci, l_logfile, verbose+) 
		    goto clean
		}


		expr = "(10.**(a/2.5))"
		insci = l_sfunction
		imexpr (expr, tmpnoise, insci, dims="auto", intype="auto", \
		    outtype="real", refim="auto", bwidth=0, btype="nearest", \
		    bpixval=0, rangecheck+, verbose-, exprdb="none")

		expr = "a/(" // objexpt // "*" // objres // ")"
		insci = imgin //  "[" // l_sci_ext // "," // ver // "]"
		imexpr (expr, tmpobj, insci, dims="auto", intype="auto", \
		    outtype="real", refim="auto", bwidth=0, btype="nearest", \
		    bpixval=0, rangecheck+, verbose-, exprdb="none")


		# Since the exposure time, resolution, and fit are
		# considered noiseless, the variance in the
		# calibration is:
		#   var(objin) / (objres*o_exptime*tmpnoise)**2

		expr = "a/(b**2)/(" // objres // "**2)/(" \
		    // objexpt // "**2)"
		invar = imgin //  "[" // l_var_ext // "," // ver // "]"
		imexpr (expr, tmpvar, insci, tmpnoise, dims="auto", \
		    intype="auto", outtype="real", refim="auto", bwidth=0, \
		    btype="nearest", bpixval=0, rangecheck+, verbose-, \
		    exprdb="none")

		if (1 == ver) {
		    indq = imgin //  "[" // l_dq_ext // "," // ver // "]"
		    tmpdq = mktemp ("tmpdq")
		    imagesdel = imagesdel // "," // tmpdq
		    imcopy (indq, tmpdq, verbose-, >& "dev$null")
		    wmef (tmpsci // "," // tmpvar // "," // tmpdq, \
			imgout, extnames=l_sci_ext // "," // l_var_ext \
			// "," // l_dq_ext, phu=imgin, verbose-)
		    if (wmef.status != 0) {
			printlog ("ERROR - NSCALIBRATE: Failed to create " \
			    // imgout, l_logfile, verbose+) 
			goto clean
		    }
		} else {
		    outsci = imgout // "[" // l_sci_ext // "," // ver \
			// ",append]"
		    imcopy (tmpsci, outsci, verbose-)
		    outvar = imgout // "[" // l_var_ext // "," // ver \
			// ",append]"
		    imcopy (tmpvar, outvar, verbose-)
		    indq = imgin //  "[" // l_dq_ext // "," // ver // "]"
		    outdq = imgout // "[" // l_dq_ext // "," // ver \
			// ",append]"
		    imcopy (indq, outdq, verbose-)
		}
	    }
	}

clean:
	delete (filesdel, ver-, >& "dev$null")
	imdelete (imagesdel, ver-, >& "dev$null")

	printlog ("", l_logfile, l_verbose)
	if (status == 0)
	    printlog ("NSCALIBRATE: Exit status good", l_logfile, l_verbose)
	printlog ("---------------------------------------------------\
	    ----------------------------", l_logfile, l_verbose)

end
