# Copyright(c) 2004 Association of Universities for Research in Astronomy, Inc.

#
# not hard coded any more define MDFEXTNAME	"MINIMAL.TAB"
#

# This file contains:
#         gdpropagate(...) - 
#
# Support routines:
#         gdpropagate(...) - Short description
#
# See also:
#         gdpropagate(...) - Short description

#
# ... define statements ...
#

# GDPROPAGATE --
#	This routine checks to see if key files have been propagated based
# 	on Gemini MEF Data Type.  (WARNING: Data Type Currently
# 	Ignored... propagates 	MDF, aka MINIMAL.TAB extensions)
# NOTE:: TODO:: I want to put PHU propagation in here!

procedure gdpropagate (source, dest, typename)
char source[ARB]
char dest[ARB]
char typename[ARB]
#
# locals below
#
char mdf_ext[SZ_LINE]
pointer smep	# for mefio memap
pointer smef, dmef # for fitsutil manipulations
int	mdfind		# mdf index (aka mdf "group" number)
bool ldebug
pointer mef_open()
int meindbnv()
pointer memap()
char tmpstr[SZ_LINE]
bool verbose
bool clgetb()

begin
	
	ldebug = true

    call clgstr("mdf_ext", mdf_ext, SZ_LINE)
    verbose= clgetb("verbose")
# memap
	smep = memap(source)

# getindex by name and ver (get just one (NOTE::is that ok?))
	mdfind = meindbnv(smep, mdf_ext, -1)

	if (mdfind > 0)
	{
		if (verbose) {
			call sprintf(tmpstr, SZ_LINE, "Going to copy MDF from %s[%d]")
			call pargstr(source)
			call pargi(mdfind)
            call log_info(tmpstr)
		}
	}
	else
	{
        if (verbose){
		    call log_info("No MDF present in source");
        }
		return
	}

# use fitsutil open source
	smef = mef_open(source, READ_ONLY, 0)
	
# use fitsutil open dest
	dmef = mef_open(dest, APPEND, 0)
	
# use fitsutil to copy source to dest
	call mef_copy_extn (smef, dmef, mdfind)
	
# use fitsutil close dest
	call mef_close(dmef)
	
# use fitsutil close source
	call mef_close(smef)

	call meunmap(smep)
end
